import matplotlib.pyplot as plt
import numpy as np
from itertools import cycle, islice


# todo: change the return default statement after data is there for other plots

def create_line_plot_monthly(data, alertType, dataType):
    if not data[0]:
        return 'src/default_image.png'
    fig = plt.figure(figsize=(40, 6))
    ax = plt.gca()
    y = data[1]
    ax.plot(y, lw=4, color='mediumpurple')
    ax.spines['top'].set_visible(False)
    ax.spines['right'].set_visible(False)
    ax.grid(axis='y', color="dimgray", linestyle='dashed', alpha=0.8, linewidth=1, dashes=(50, 50))
    ax.xaxis.set_major_locator(plt.MaxNLocator(2))
    ax.set_xticks(ticks=[0, 30], labels=[data[0][0], data[0][1]])
    ax.legend().remove()
    ax.tick_params(axis='x', which='major', labelsize=22, left=False, bottom=False)
    ax.tick_params(axis='y', labelsize=30, left=False)
    ax.set(xlabel=None)
    plot_name = 'line_chart_monthly_' + alertType + '_' + dataType + '.svg'
    fig.savefig(plot_name, format='svg', bbox_inches='tight')
    return plot_name


def create_area_plot():
    # todo:Create widgets after processing data for this chart
    # fig = plt.figure(figsize=(30,12))
    # ax=plt.gca()
    # date = ["Nov 9 2023", "Nov 10 2023", "Nov 11 2023", "Nov 12 2023", "Nov 13 2023", "Nov 14 2023", "Nov 15 2023",
    #         "Nov 16 2023"]
    # y = np.array([8, 0.5, 30, 7, 28, 34, 21, 15])
    # d = np.array([7, 0.7, 40, 5, 9, 7.6, 12, 14])
    # a = np.array([2, 0.1, 50, 4, 2, 0.1, 50, 4])
    # areas = ax.stackplot(date,y,d,a,colors= list(islice(cycle(['royalblue', 'lightskyblue', 'mediumorchid']), None, len(y))))
    # urls = ['https://www.bbc.com/news', 'https://www.google.com/', 'https://www.vmware.com/']
    # # areas.set_urls(urls)
    # # for area,url in zip(areas,urls):
    # #     if url:
    # #         areas.set_urls([url])
    # my_labels = ["Windows Assets", "MacOS Assets", "Linux Assets"]
    # lgnd = ax.legend(loc="lower left", ncol=3, bbox_to_anchor=(0.3, -0.22), frameon=False, labels=my_labels, fontsize='large', handleheight=4, markerfirst=False, handlelength=6)
    # ax.spines['top'].set_visible(False)
    # ax.spines['right'].set_visible(False)
    # ax.grid(axis = 'y', color = "grey", linestyle='dashed', alpha = 1, linewidth = 0.9,  dashes=(50, 50))
    # ax.tick_params(axis='x', which='major', labelsize=16, left=False, bottom=False)
    # ax.tick_params(axis='y',labelsize=16,  left=False)
    # ax.text(x=0.9, y=-23, s="Operating System", fontsize='x-large', fontweight='bold', fontstyle='italic')
    # ax.set(xlabel=None)
    # fig.subplots_adjust(bottom=0.3)
    # fig.savefig('area_chart_2_monthly_v1.svg', format='svg',  bbox_inches='tight')
    return 'src/default_image.png'


def create_barh_asset(data, alertType):
    fig = plt.figure(figsize=(32, 19))
    if not data[0]:
        return 'src/default_image.png'
    ax = plt.gca()
    bars = ax.barh(data[0], data[1], color='mediumorchid', height=0.4)
    urls = ['https://www.bbc.com/news', 'https://www.google.com/', 'https://www.vmware.com/', 'https://www.msn.com/',
            'https://www.w3schools.com/', 'https://www.github.com/']
    for bar, url in zip(bars, urls):
        if url:
            bar.set_url(url)

    ax.tick_params(axis='x', which='major', labelsize=36, bottom=False)
    ax.tick_params(axis='y', which='major', labelsize=36, left=False)
    ax.spines['top'].set_visible(False)
    ax.spines['right'].set_visible(False)
    ax.set(xlabel=None)
    ax.set(ylabel=None)
    fig.subplots_adjust(left=0.25)
    plot_name = 'barh_asset_monthly_' + alertType + '.svg'
    fig.savefig(plot_name, format='svg', bbox_inches='tight')
    return plot_name


def create_barh_process(data, alertType):
    fig = plt.figure(figsize=(32, 19))
    if not data[0]:
        return 'src/default_image.png'
    ax = plt.gca()
    bars = ax.barh(data[0], data[1], color='royalblue', height=0.4)
    urls = ['https://www.bbc.com/news', 'https://www.google.com/', 'https://www.vmware.com/', 'https://www.msn.com/',
            'https://www.w3schools.com/', 'https://www.github.com/']
    for bar, url in zip(bars, urls):
        if url:
            bar.set_url(url)

    ax.tick_params(axis='x', which='major', labelsize=36, bottom=False)
    ax.tick_params(axis='y', which='major', labelsize=36, left=False)
    ax.spines['top'].set_visible(False)
    ax.spines['right'].set_visible(False)
    ax.set(xlabel=None)
    ax.set(ylabel=None)
    fig.subplots_adjust(left=0.25)
    plot_name = 'barh_process_monthly_' + alertType + '.svg'
    fig.savefig(plot_name, format='svg', bbox_inches='tight')
    return plot_name


def create_barh_4_plot():
    # todo:Create widgets after processing data for this chart
    # fig = plt.figure(figsize=(80,30))
    # ax=plt.gca()
    # width=0.1
    # f = np.array([10, 1, 8.0, 3, 4, 7 ,1.7 ,20])
    # e = np.array([8, 0.5, 3.0, 7, 2.8, 3.4, 2.1, 1.5])
    # d = np.array([7, 0.7, 4.0, 5, 9, 7.6, 1.2, 14])
    # a = np.array([2, 0.1, 5.0, 4, 2, 0.1, 5.0, 4])
    # b = np.array([3, 0.9, 6.0, 9, 3, 0.9, 6.0, 9])
    # c = np.array([4, 0.3, 7.0, 10, 3, 0.9, 6.0, 9])
    # x = np.arange(8)
    # date = ["Nov 9 2023", "Nov 10 2023", "Nov 11 2023", "Nov 12 2023", "Nov 13 2023", "Nov 14 2023", "Nov 15 2023",
    #         "Nov 16 2023"]
    # # d = np.column_stack((a, b, c, d, e, f))
    # # df = pd.DataFrame(d, columns=["A", "B", "C", "D", "E", "F"])
    # # df["X"] = date
    #
    # bars_1 = plt.bar(x,a, width=0.1, color = '#2475D9')
    # bars_2 = plt.bar(x+width,b, width=0.1, color = '#68ACFF' )
    # bars_3 = plt.bar(x+width*2,c, width=0.1, color = '#D3E7FF')
    # bars_4 = plt.bar(x+width*3,d, width=0.1, color = 'mediumorchid')
    # bars_5 = plt.bar(x+width*4,e, width=0.1, color = 'plum')
    # bars_6 = plt.bar(x+width*5,f, width=0.1, color = '#E7D5EE' )
    # urls = ['https://www.bbc.com/news', 'https://www.google.com/', 'https://www.vmware.com/', 'https://www.msn.com/', 'https://www.w3schools.com/', 'https://www.github.com/']
    # for bars in zip(bars_1, bars_2, bars_3,bars_4,bars_5, bars_6):
    #     for bar, url in zip(bars, urls):
    #         if url:
    #             bar.set_url(url)
    #
    # # plt.title(r"$\bf{Severity \; scores  \; of \; likely \; threats}$" + "\n November 9-16,2023", fontsize = 100)
    # plt.xticks(ticks= x+width,labels=date)
    # # plt.yticks(fontsize = 60)
    # # ax = plt.gca()
    # #ax.legend(bbox_to_anchor=(1.0, 0.0))
    # my_labels = ["10 (Priority)",  "9 (Priority)", "8 (Priority)","7 (Eligible)","6 (Eligible)" ,  "5 (Eligible)"]
    # ax.legend(loc="lower left", ncol=8, bbox_to_anchor=(0.1, -0.4),  frameon=False, markerfirst=False, labels = my_labels, fontsize = 45, handleheight=4,  handlelength=6)
    # ax.spines['top'].set_visible(False)
    # ax.spines['right'].set_visible(False)
    # ax.grid(axis = 'y', color = "dimgray", linestyle='dashed', alpha = 1, linewidth = 1.7, dashes=(50, 50))
    # #ax.grid(color='r', linestyle='-', linewidth=2)
    # ax.set(xlabel=None)
    # ax.tick_params(axis='x', which='major', labelsize=60, left= False, bottom = False)
    # ax.tick_params(axis='y', labelsize=90, left= False)
    # ax.text(x=-0.4, y= -7, s = "Severity", fontsize = '50', fontweight='heavy', fontstyle='italic')
    # #plt.legend(loc="lower left", ncol=len(df.columns))
    # fig.subplots_adjust(bottom = 0.3)
    # fig.savefig('bar_chart_4_monthly_v3.svg', format='svg', bbox_inches='tight')
    return 'src/default_image.png'


def create_pie_3_chart(dct, alertType):
    if not dct or all(x == 0 for x in list(dct.values())):
        return 'src/default_image.png'
    fig = plt.figure(figsize=(80, 25))
    ax = plt.gca()
    my_labels = []
    ls_x = []
    for k in list(dct.keys()):
        if dct[k] != 0:
            ls_x.append(dct[k])
            if int(k) >= 8:
                my_labels.append(str(k) + ' (Priority)')
            else:
                my_labels.append(str(k) + ' (Eligible)')
    x = np.array(ls_x)
    pies = ax.pie(x, radius=3, colors=list(
        islice(cycle(['#D3E7FF', '#68ACFF', '#2475D9', '#E7D5EE', 'mediumorchid']), None, len(x))), labels=my_labels,
                  textprops={'weight': 'heavy', 'fontsize': 120})
    urls = ['https://www.bbc.com/news', 'https://www.google.com/', 'https://www.vmware.com/', 'https://www.msn.com/',
            'https://www.w3schools.com/', 'https://www.github.com/']
    for wedge, url in zip(pies[0], urls):
        wedge.set_url(url)
    ax.legend().remove()
    ax.set(xlabel=None)
    ax.set(ylabel=None)
    plot_name = 'pie_severity_monthly_' + alertType + '.svg'
    fig.savefig(plot_name, format='svg', bbox_inches='tight')
    return plot_name


def create_line_plots():
    # todo:Create widgets after processing data for this chart
    # fig = plt.figure(figsize=(70,23))
    # ax=plt.gca()
    # date = ["Nov 9 2023", "Nov 10 2023", "Nov 11 2023", "Nov 12 2023", "Nov 13 2023", "Nov 14 2023", "Nov 15 2023",
    #         "Nov 16 2023"]
    # y = np.array([8, 0.5, 20, 7, 16, 24, 21, 15])
    # ax.plot(y, lw=12, color = 'mediumpurple')
    # ax.spines['top'].set_visible(False)
    # ax.spines['right'].set_visible(False)
    # ax.grid(axis = 'y', color = "dimgray", linestyle='dashed', alpha = 1, linewidth = 2,  dashes=(50, 50))
    # ax.set_xticks(ticks = np.arange(8),labels=date)
    # ax.set_yticks(ticks = np.arange(0,30,5))
    # ax.legend().remove()
    # ax.tick_params(axis='x', which='major', labelsize=60, left= False, bottom = False)
    # ax.tick_params(axis='y', labelsize=90, left= False)
    # ax.set(xlabel=None)
    # fig.savefig('line_chart_1_monthly_v3.svg', format='svg', bbox_inches='tight')
    return 'src/default_image.png'


def create_multi_line_plots():
    # todo:Create widgets after processing data for this chart
    # fig = plt.figure(figsize=(60,25))
    # my_labels = ["8 (Priority)", "10 (Priority)", "7 (Eligible)" , "5 (Eligible)"]
    # ax=plt.gca()
    # date = ["May 2023", "Jun 2023", "July 2023", "Aug 2023", "Sep 2023", "Oct 2023"]
    # y = np.array([8, 0.5, 30, 7, 28, 34])
    # d = np.array([7, 0.7, 40, 5, 9, 7.6])
    # a = np.array([2, 0.1, 50, 4, 2, 0.1])
    # ax.plot(date,y,lw=12, color = 'purple')
    # ax.plot(date,d,lw=12, color = 'green')
    # ax.plot(date,a,lw=12, color = 'dodgerblue')
    # plt.ylabel("Average Alerts per Day per Asset", fontsize = '20')
    # handles = [
    #     matplotlib.patches.Patch(facecolor="purple", label="Customer Average"),
    #     matplotlib.patches.Patch(facecolor="dodgerblue", label="Size Average"),
    #     matplotlib.patches.Patch(facecolor="green", label="Industry Average"),
    # ]
    #
    # #ax.legend(loc="lower left", ncol=3, bbox_to_anchor=(0.3, -0.2), frameon=False, fontsize='xx-small')
    # ax.spines['top'].set_visible(False)
    # ax.spines['right'].set_visible(False)
    # ax.grid(axis = 'y', color = "gray", linestyle='dashed', alpha = 0.5, linewidth = 1,  dashes=(10, 2))
    # ax.tick_params(axis='x', which='major', labelsize=25, left=False, bottom=False)
    # ax.tick_params(axis='y', left=False, labelsize=48)
    # ax.legend(loc="lower left", ncol=8, bbox_to_anchor=(0.28, -0.3),  frameon=False, markerfirst=False, labels = my_labels, fontsize = 30, handles=handles, handleheight=4,  handlelength=6)
    # ax.text(x=0.65, y=-16.5, s="Assert Alerts Type", fontsize='20', fontweight='heavy')
    # ax.set(xlabel=None)
    # fig.subplots_adjust(bottom=0.3)
    # fig.savefig('multi_line_chart_monthly_v1.svg', format='svg', bbox_inches='tight')
    return 'src/default_image.png'
